/* eslint-disable */
'use strict'

var sakepDict = {}

var byte_6B540 = [0, 1, 2, 3, 0, 1, 3, 2, 0, 2, 1, 3, 0, 2, 3, 1, 0,
    3, 1, 2, 0, 3, 2, 1, 1, 0, 2, 3, 1, 0, 3, 2, 1, 2,
    0, 3, 1, 2, 3, 0, 1, 3, 0, 2, 1, 3, 2, 0, 2, 0, 1,
    3, 2, 0, 3, 1, 2, 1, 0, 3, 2, 1, 3, 0, 2, 3, 0, 1,
    2, 3, 1, 0, 3, 0, 1, 2, 3, 0, 2, 1, 3, 1, 0, 2, 3,
    1, 2, 0, 3, 2, 0, 1, 3, 2, 1, 0
]

function SWAPv2_Process(a1, a2, a3, offset) {
    var a4 = new Uint8Array(16)

    var v102 = a1
    var v114 = 0

    var result = 0

    if (a2 === 197312) {
        v114 = 12
    } else if (a2 === 230192) {
        v114 = 14
    } else {
        if (a2 !== 164432) {
            return { error: -2147483646 }
        }
        v114 = 10
    }

    var v119 = new Array(16)
    var v120 = new Array(16)
    var v121 = new Array(16)

    var v112 = v114 << 14 // a1
    var v106 = 32 * (v114 + 1) + (v114 << 14) // a1
    var v4 = a3[offset + 0]
    var v5 = a1[v112 + 0] & 0xF
    v121[v5] = a3[offset + 0]
    v120[v5] = v4
    var v6 = v114 << 14 // a1
    var v7 = a3[offset + 1]
    var v8 = a1[v112 + 1] & 0xF
    v121[v8] = v7
    v120[v8] = v7
    var v9 = a3[offset + 2]
    var v10 = a1[v6 + 2] & 0xF
    v121[v10] = v9
    v120[v10] = v9
    var v11 = a3[offset + 3]
    var v12 = a1[v6 + 3] & 0xF
    v121[v12] = v11
    v120[v12] = v11
    var v13 = a3[offset + 4]
    var v14 = a1[v6 + 4] & 0xF
    v121[v14] = v13
    v120[v14] = v13
    var v15 = a3[offset + 5]
    var v16 = a1[v6 + 5] & 0xF
    v121[v16] = v15
    v120[v16] = v15
    var v17 = a3[offset + 6]
    var v18 = a1[v6 + 6] & 0xF
    v121[v18] = v17
    v120[v18] = v17
    var v19 = a3[offset + 7]
    var v20 = a1[v6 + 7] & 0xF
    v121[v20] = v19
    v120[v20] = v19
    var v21 = a3[offset + 8]
    var v22 = a1[v6 + 8] & 0xF
    v121[v22] = v21
    v120[v22] = v21
    var v23 = a3[offset + 9]
    var v24 = a1[v6 + 9] & 0xF
    v121[v24] = v23
    v120[v24] = v23
    var v25 = a3[offset + 10]
    var v26 = a1[v6 + 10] & 0xF
    v121[v26] = v25
    v120[v26] = v25
    var v27 = a3[offset + 11]
    var v28 = a1[v6 + 11] & 0xF
    v121[v28] = v27
    v120[v28] = v27
    var v29 = a3[offset + 12]
    var v30 = a1[v6 + 12] & 0xF
    v121[v30] = v29
    v120[v30] = v29
    var v31 = a3[offset + 13]
    var v32 = a1[v6 + 13] & 0xF
    v121[v32] = v31
    v120[v32] = v31
    var v33 = a3[offset + 14]
    var v34 = a3[offset + 15]
    var v35 = a1[v6 + 14] & 0xF
    v121[v35] = v33
    v120[v35] = v33
    var v36 = a1[v6 + 15] & 0xF
    v121[v36] = v34
    v120[v36] = v34
    var v37Offset = v114 << 14
    var v37 = v37Offset // v102

    var v115 = 0
    for (var i = 0; v115 < v114 - 1; i = v115) {
        v119[0] = 4 * (16 * ((i << 8) + (v121[0] >> 4)) + (v121[0] & 0xF)) // v102
        v119[1] = 4 * (16 * ((v121[1] >> 4) + 16 * (16 * i + 1)) + (v121[1] & 0xF)) // v102
        v119[2] = 4 * (16 * ((v121[2] >> 4) + 16 * (16 * i + 2)) + (v121[2] & 0xF)) // v102
        v119[3] = 4 * (16 * ((v121[3] >> 4) + 16 * (16 * i + 3)) + (v121[3] & 0xF)) // v102
        v119[4] = 4 * (16 * ((v121[4] >> 4) + 16 * (16 * i + 4)) + (v121[4] & 0xF)) // v102
        v119[5] = 4 * (16 * ((v121[5] >> 4) + 16 * (16 * i + 5)) + (v121[5] & 0xF)) // v102
        v119[6] = 4 * (16 * ((v121[6] >> 4) + 16 * (16 * i + 6)) + (v121[6] & 0xF)) // v102
        v119[7] = 4 * (16 * ((v121[7] >> 4) + 16 * (16 * i + 7)) + (v121[7] & 0xF)) // v102
        v119[8] = 4 * (16 * ((v121[8] >> 4) + 16 * (16 * i + 8)) + (v121[8] & 0xF)) // v102
        v119[9] = 4 * (16 * ((v121[9] >> 4) + 16 * (16 * i + 9)) + (v121[9] & 0xF)) // v102
        v119[10] = 4 * (16 * ((v121[10] >> 4) + 16 * (16 * i + 10)) + (v121[10] & 0xF)) // v102
        v119[11] = 4 * (16 * ((v121[11] >> 4) + 16 * (16 * i + 11)) + (v121[11] & 0xF)) // v102
        v119[12] = 4 * (16 * ((v121[12] >> 4) + 16 * (16 * i + 12)) + (v121[12] & 0xF)) // v102
        v119[13] = 4 * (16 * ((v121[13] >> 4) + 16 * (16 * i + 13)) + (v121[13] & 0xF)) // v102
        v119[14] = 4 * (16 * ((v121[14] >> 4) + 16 * (16 * i + 14)) + (v121[14] & 0xF)) // v102
        v119[15] = 4 * (16 * (16 * (16 * i + 15) + (v121[15] >> 4)) + (v121[15] & 0xF)) // v102

        v115 = i + 1

        var v38 = v102[v37 + 36] & 0xF
        var v39 = v119[v38]
        var v40 = 4 * i
        var v41 = a1[v106 + v40 + (v120[v38] & 3)]
        var v42 = v102[v37 + 37] & 0xF
        var v43 = v119[v42]
        var v44 = a1[v106 + v40 + (v120[v42] & 3)]
        var v45 = v102[v37 + 38] & 0xF
        var v46 = v119[v45]
        var v47 = a1[v106 + v40 + (v120[v45] & 3)]
        var v48 = v102[v37 + 39] & 0xF
        var v49 = v119[v48]
        var v50 = a1[v106 + v40 + (v120[v48] & 3)]
        var v51 = 4 * v47

        v121[v102[v37 + 32] & 0xF] = v102[v43 + byte_6B540[4 * v44]] ^ v102[v39 + byte_6B540[4 * v41]] ^ v102[v46 + byte_6B540[4 * v47]] ^ v102[v49 + byte_6B540[4 * v50]]
        var v52 = 4 * v50 // byte_6B540
        v121[v102[v37 + 33] & 0xF] = v102[v49 + byte_6B540[v52 + 1]] ^ v102[v46 + byte_6B540[v51 + 1]] ^ v102[v43 + byte_6B540[4 * v44 + 1]] ^ v102[v39 + byte_6B540[4 * v41 + 1]]
        v121[v102[v37 + 34] & 0xF] = v102[v49 + byte_6B540[v52 + 2]] ^ v102[v43 + byte_6B540[4 * v44 + 2]] ^ v102[v39 + byte_6B540[4 * v41 + 2]] ^ v102[v46 + byte_6B540[v51 + 2]]
        v121[v102[v37 + 35] & 0xF] = v102[v43 + byte_6B540[4 * v44 + 3]] ^ v102[v39 + byte_6B540[4 * v41 + 3]] ^ v102[v46 + byte_6B540[v51 + 3]] ^ v102[v49 + byte_6B540[v52 + 3]]

        var v53 = v102[v37 + 44] & 0xF
        var v54 = v119[v53]
        var v55 = a1[v106 + v40 + (v120[v53] & 3)]
        var v56 = v102[v37 + 45] & 0xF
        var v57 = v119[v56]
        var v58 = a1[v106 + v40 + (v120[v56] & 3)]
        var v59 = v102[v37 + 46] & 0xF
        var v60 = v119[v59]
        var v61 = a1[v106 + v40 + (v120[v59] & 3)]
        var v62 = v102[v37 + 47] & 0xF
        var v63 = v119[v62]
        var v64 = a1[v106 + v40 + (v120[v62] & 3)]
        var v65 = 4 * v61

        v121[v102[v37 + 40] & 0xF] = v102[v57 + byte_6B540[4 * v58]] ^ v102[v54 + byte_6B540[4 * v55]] ^ v102[v60 + byte_6B540[4 * v61]] ^ v102[v63 + byte_6B540[4 * v64]]
        var v66 = 4 * v64 // byte_6B540
        v121[v102[v37 + 41] & 0xF] = v102[v63 + byte_6B540[v66 + 1]] ^ v102[v60 + byte_6B540[v65 + 1]] ^ v102[v57 + byte_6B540[4 * v58 + 1]] ^ v102[v54 + byte_6B540[4 * v55 + 1]]
        v121[v102[v37 + 42] & 0xF] = v102[v63 + byte_6B540[v66 + 2]] ^ v102[v57 + byte_6B540[4 * v58 + 2]] ^ v102[v54 + byte_6B540[4 * v55 + 2]] ^ v102[v60 + byte_6B540[v65 + 2]]
        v121[v102[v37 + 43] & 0xF] = v102[v57 + byte_6B540[4 * v58 + 3]] ^ v102[v54 + byte_6B540[4 * v55 + 3]] ^ v102[v60 + byte_6B540[v65 + 3]] ^ v102[v63 + byte_6B540[v66 + 3]]

        var v67 = v102[v37 + 52] & 0xF
        var v68 = v119[v67]
        var v69 = a1[v106 + v40 + (v120[v67] & 3)]
        var v70 = v102[v37 + 53] & 0xF
        var v71 = v119[v70]
        var v72 = a1[v106 + v40 + (v120[v70] & 3)]
        var v73 = v102[v37 + 54] & 0xF
        var v74 = v119[v73]
        var v75 = a1[v106 + v40 + (v120[v73] & 3)]
        var v76 = v102[v37 + 55] & 0xF
        var v77 = v119[v76]
        var v78 = a1[v106 + v40 + (v120[v76] & 3)]
        var v79 = 4 * v75

        v121[v102[v37 + 48] & 0xF] = v102[v71 + byte_6B540[4 * v72]] ^ v102[v68 + byte_6B540[4 * v69]] ^ v102[v74 + byte_6B540[4 * v75]] ^ v102[v77 + byte_6B540[4 * v78]]
        var v80 = 4 * v78 // byte_6B540
        v121[v102[v37 + 49] & 0xF] = v102[v77 + byte_6B540[v80 + 1]] ^ v102[v74 + byte_6B540[v79 + 1]] ^ v102[v71 + byte_6B540[4 * v72 + 1]] ^ v102[v68 + byte_6B540[4 * v69 + 1]]
        v121[v102[v37 + 50] & 0xF] = v102[v77 + byte_6B540[v80 + 2]] ^ v102[v71 + byte_6B540[4 * v72 + 2]] ^ v102[v68 + byte_6B540[4 * v69 + 2]] ^ v102[v74 + byte_6B540[v79 + 2]]
        v121[v102[v37 + 51] & 0xF] = v102[v71 + byte_6B540[4 * v72 + 3]] ^ v102[v68 + byte_6B540[4 * v69 + 3]] ^ v102[v74 + byte_6B540[v79 + 3]] ^ v102[v77 + byte_6B540[v80 + 3]]

        var v81 = v102[v37 + 60] & 0xF
        var v82 = v119[v81]
        var v83 = a1[v106 + v40 + (v120[v81] & 3)]
        var v84 = v102[v37 + 61] & 0xF
        var v85 = v119[v84]
        var v86 = a1[v106 + (v120[v84] & 3) + v40]
        var v87 = v102[v37 + 62] & 0xF
        var v88 = v119[v87]
        var v89 = v102[v37 + 63]
        var v90 = a1[v106 + (v120[v87] & 3) + v40]
        var v91 = v119[v89 & 0xF]
        var v92 = a1[v106 + v40 + (v120[v89 & 0xF] & 3)]
        var v93 = 4 * v86
        v83 *= 4

        v121[v102[v37 + 56] & 0xF] = v102[v85 + byte_6B540[4 * v86]] ^ v102[v82 + byte_6B540[v83]] ^ v102[v88 + byte_6B540[4 * v90]] ^ v102[v91 + byte_6B540[4 * v92]]
        var v94 = v83 // byte_6B540
        var v95 = 4 * v92 // byte_6B540
        v121[v102[v37 + 57] & 0xF] = v102[v91 + byte_6B540[4 * v92 + 1]] ^ v102[v88 + byte_6B540[4 * v90 + 1]] ^ v102[v85 + byte_6B540[v93 + 1]] ^ v102[v82 + byte_6B540[v94 + 1]]
        v121[v102[v37 + 58] & 0xF] = v102[v91 + byte_6B540[v95 + 2]] ^ v102[v85 + byte_6B540[v93 + 2]] ^ v102[v82 + byte_6B540[v94 + 2]] ^ v102[v88 + byte_6B540[4 * v90 + 2]]
        v121[v102[v37 + 59] & 0xF] = v102[v82 + byte_6B540[v94 + 3]] ^ v102[v85 + byte_6B540[v93 + 3]] ^ v102[v88 + byte_6B540[4 * v90 + 3]] ^ v102[v91 + byte_6B540[v95 + 3]]

        v120[0] = v121[0]
        v120[1] = v121[1]
        var v99 = v121[1]
        v120[2] = v121[2]
        v120[3] = v121[3]
        var v104 = v121[3]
        v120[4] = v121[4]
        var v108 = v121[4]
        var v109 = v121[5]
        v120[5] = v121[5]
        v120[6] = v121[6]
        var v110 = v121[6]
        v120[7] = v121[7]
        var v111 = v121[7]
        v120[8] = v121[8]
        var v100 = v121[8]
        v120[9] = v121[9]
        var v105 = v121[9]
        v120[10] = v121[10]
        var v101 = v121[10]
        v120[11] = v121[11]
        var v107 = v121[11]
        v120[12] = v121[12]
        var v113 = v121[12]
        v120[13] = v121[13]
        var v116 = v121[13]
        v120[14] = v121[14]
        var v117 = v121[14]
        v37Offset += 32
        v37 = v37Offset
        v120[15] = v121[15]
        var v118 = v121[15]
    }

    var v96 = v121[2]
    var v97 = v112 + 32 * v114
    a4[a1[v97 + 0] & 0xF] = v102[(v115 << 14) +
        4 * (16 * (v121[0] >> 4) + (v121[0] & 0xF)) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v121[0] & 3))]]]
    a4[a1[v97 + 1] & 0xF] = v102[4 * ((v99 & 0xF) + 16 * (v99 >> 4)) +
        ((16 * v115 + 1) << 10) +
        byte_6B540[4 * a1[v106 + ((v99 & 3) + 4 * v115)]]]
    a4[a1[v97 + 2] & 0xF] = v102[4 * ((v96 & 0xF) + 16 * (v96 >> 4)) +
        ((16 * v115 + 2) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v96 & 3))]]]
    a4[a1[v97 + 3] & 0xF] = v102[4 * ((v104 & 0xF) + 16 * (v104 >> 4)) +
        ((16 * v115 + 3) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v104 & 3))]]]
    a4[a1[v97 + 4] & 0xF] = v102[4 * ((v108 & 0xF) + 16 * (v108 >> 4)) +
        ((16 * v115 + 4) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v108 & 3))]]]
    a4[a1[v97 + 5] & 0xF] = v102[4 * ((v109 & 0xF) + 16 * (v109 >> 4)) +
        ((16 * v115 + 5) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v109 & 3))]]]
    a4[a1[v97 + 6] & 0xF] = v102[4 * ((v110 & 0xF) + 16 * (v110 >> 4)) +
        ((16 * v115 + 6) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v110 & 3))]]]
    a4[a1[v97 + 7] & 0xF] = v102[4 * ((v111 & 0xF) + 16 * (v111 >> 4)) +
        ((16 * v115 + 7) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v111 & 3))]]]
    a4[a1[v97 + 8] & 0xF] = v102[4 * ((v100 & 0xF) + 16 * (v100 >> 4)) +
        ((16 * v115 + 8) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v100 & 3))]]]
    a4[a1[v97 + 9] & 0xF] = v102[4 * ((v105 & 0xF) + 16 * (v105 >> 4)) +
        ((16 * v115 + 9) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v105 & 3))]]]
    a4[a1[v97 + 10] & 0xF] = v102[4 * ((v101 & 0xF) + 16 * (v101 >> 4)) +
        ((16 * v115 + 10) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v101 & 3))]]]
    a4[a1[v97 + 11] & 0xF] = v102[4 * ((v107 & 0xF) + 16 * (v107 >> 4)) +
        ((16 * v115 + 11) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v107 & 3))]]]
    a4[a1[v97 + 12] & 0xF] = v102[4 * ((v113 & 0xF) + 16 * (v113 >> 4)) +
        ((16 * v115 + 12) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v113 & 3))]]]
    a4[a1[v97 + 13] & 0xF] = v102[4 * ((v116 & 0xF) + 16 * (v116 >> 4)) +
        ((16 * v115 + 13) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v116 & 3))]]]
    a4[a1[v97 + 14] & 0xF] = v102[4 * ((v117 & 0xF) + 16 * (v117 >> 4)) +
        ((16 * v115 + 14) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v117 & 3))]]]
    a4[a1[v97 + 15] & 0xF] = v102[4 * (16 * (v118 >> 4) + (v118 & 0xF)) +
        ((16 * v115 + 15) << 10) +
        byte_6B540[4 * a1[v106 + (4 * v115 + (v118 & 3))]]]

    var result = {}
    result.value = a4

    return result
}

// pre-computed keys
var publicKey = '2cb12bb2cbf7cec713c0fff7b59ae68a96784ae517f41d259a45d20556177c0ffe951ca60ec03a990c9412619d1bee30adc7773088c5721664cffcedacf6d251cb4b76e2fd7aef09b3ae9f9496ac8d94ed2b262eee37291c8b237e880cc7c021fb1be0881f3d0bffa4234d3b8e6a61530c00473ce169c025f47fcc001d9b8051'
var privateKey = '2fd6334713816fae018cdee4656c5033a8d6b00e8eaea07b3624999242e96247112dcd019c4191f4643c3ce1605002b2e506e7f1d1ef8d9b8044e46d37c0d5263216a87cd783aa185490436c4a0cb2c524e15bc1bfeae703bcbc4b74a0540202e8d79cadaae85c6f9c218bc1107d1f5b4b9bd87160e782f4e436eeb17485ab4d'

var prime = 'b361eb0ab01c3439f2c16ffda7b05e3e320701ebee3e249123c3586765fd5bf6c1dfa88bb6bb5da3fde74737cd88b6a26c5ca31d81d18e3515533d08df619317063224cf0943a2f29a5fe60c1c31ddf28334ed76a6478a1122fb24c4a94c8711617ddfe90cf02e643cd82d4748d6d4a7ca2f47d88563aa2baf6482e124acd7dd'
var generator = 'abf9ef8e957c6ee4d490f9a03a64782e3e59976e212dd1bc7ee49932d3c40d8a799eeb399aa9e0fe000ca9bbb133af9c78a875bcde1c328493a27029035a868a91449326d91d4d712af352910be8c5fb985917411edd2a428bd6151eda08f0c18547c04d193c3d30588250e2fe60b847f250915e56e8f25557194618e7832f73'

var generateServerHello = function(userId, pin) {
    sakepDict = {}

    var dataEncTbl = asmCrypto.hex_to_bytes(encTbl.encTbl)
    var aesKey = asmCrypto.SHA1.bytes(asmCrypto.string_to_bytes(pin)).subarray(0, 16)

    var encrypted = asmCrypto.AES_CBC.encrypt(asmCrypto.hex_to_bytes(publicKey), aesKey, false)

    var swapped = new Uint8Array(encrypted.length)
    var offset = 0
    do {
        var result = SWAPv2_Process(dataEncTbl, 0x28250, encrypted, offset)
        if (result.value) {
            swapped.set(result.value, offset)
        } else{
            log("DEBUG", 'error');
            // log.info(result.error)
        }
        offset += 16
    } while (offset < 128)

    /*
    format:
      0102
      0000000000000000
      8a
      000000
      06
      363534333231
      [[swapped]]
      0000000000
    */
    var userIdByteLength = userId.length
    var data = '000000' +
        (userIdByteLength < 10 ? '0' : '') + userIdByteLength.toString(16) +
        asmCrypto.bytes_to_hex(asmCrypto.string_to_bytes(userId)) +
        asmCrypto.bytes_to_hex(swapped)

    sakepDict['pin'] = pin
    sakepDict['userId'] = userId
    sakepDict['aesKey'] = aesKey
    sakepDict['hash'] = asmCrypto.SHA1.hex(asmCrypto.hex_to_bytes(data))

    return ('0102' +
        '0000000000000000' +
        (userIdByteLength + 132).toString(16) +
        data +
        '0000000000').toUpperCase()
}

function convertUint8ToUint32(bytes, offset) {
    var uint32 = 0
    for (var i = offset; i < offset + 4; i++) {
        uint32 = (uint32 << 2) + bytes[i]
    }
    return uint32
}

function simpleTransform(table, nr, input) {
    var num1 = nr * 16384
    var num2 = (nr + 1) * 32
    return SimpleTransform_ProcNormal(table, num1, num2 + num1, nr, input)
}

function SimpleTransform_ProcNormal(table, pbox /* table */ , wpbox /* table */ , nr, input) {
    var output = new Uint8Array(16)

    var byte_519E5 = [0, 1, 2, 3, 0, 1, 3, 2, 0, 2, 1, 3, 0, 2, 3, 1, 0,
        3, 1, 2, 0, 3, 2, 1, 1, 0, 2, 3, 1, 0, 3, 2, 1, 2,
        0, 3, 1, 2, 3, 0, 1, 3, 0, 2, 1, 3, 2, 0, 2, 0, 1,
        3, 2, 0, 3, 1, 2, 1, 0, 3, 2, 1, 3, 0, 2, 3, 0, 1,
        2, 3, 1, 0, 3, 0, 1, 2, 3, 0, 2, 1, 3, 1, 0, 2, 3,
        1, 2, 0, 3, 2, 0, 1, 3, 2, 1, 0
    ]

    var v47 = new Uint8Array(16)
    var v48 = new Uint8Array(16)

    var v5 = 0
    do {
        var v8 = 0
        do {
            var v6 = input[v5 + v8]
            var v7 = table[pbox + v5 + v8] & 0xf
            v48[v7] = v6
            v47[v7] = v6
            v8++
        } while (v8 != 8)
        v5 += 8
    } while (v5 != 16)

    var num20 = nr - 1
    var arrayTypeBy137EPtr2 = 6
    var num1 = 0

    do {
        var num4 = num1 << 4
        var num5 = 3 // v47
        var num6 = 2 // v47
        var num7 = 1 // v47
        var arrayTypeBy0BaEPtr = 0 // v47
        var num8 = (num4 + 3) * 16
        var num9 = (num4 + 2) * 16
        var num10 = 1024
        var arrayTypeBy0BaPaY03E = new Uint32Array(64)
        var arrayTypeBy03EPtr = 0 // arrayTypeBy0BaPaY03E
        var num11 = num4 * 16
        var num12 = num11
        var num13 = 12 // arrayTypeBy0BaPaY03E
        var num14 = 8 // arrayTypeBy0BaPaY03E
        var num15 = 4 // arrayTypeBy0BaPaY03E
        do {
            var num16 = v47[arrayTypeBy0BaEPtr]
            arrayTypeBy0BaPaY03E[arrayTypeBy03EPtr] = (((num16 >> 4) + num12) * 16 + (num16 & 0xf)) * 4 // table
            var num17 = v47[num7]
            arrayTypeBy0BaPaY03E[num15] = (((num17 >> 4) + num11) * 16 + (num17 & 0xf)) * 4 + num10 // table
            var num18 = v47[num6]
            arrayTypeBy0BaPaY03E[num14] = (((num18 >> 4) + num9) * 16 + (num18 & 0xf)) * 4 // table
            var num19 = v47[num5]
            arrayTypeBy0BaPaY03E[num13] = (((num19 >> 4) + num8) * 16 + (num19 & 0xf)) * 4 // table
            num12 += 64
            num9 += 64
            num8 += 64
            arrayTypeBy0BaEPtr += 4
            num7 += 4
            num10 += 4096
            arrayTypeBy03EPtr += 16
            num15 += 16
            num14 += 16
            num13 += 16
            num6 += 4
            num5 += 4
        } while (num10 < 17408)
        ++num1
        arrayTypeBy137EPtr2 += 32
        var arrayTypeBy137EPtr3 = arrayTypeBy137EPtr2
        var num21 = 4
        do {
            var num16 = table[pbox + arrayTypeBy137EPtr3 + 1] & 0xf
            var num17 = num16 * 4 // arrayTypeBy0BaPaY03E
            var num18 = table[pbox + arrayTypeBy137EPtr3] & 0xf
            var num19 = num18 * 4 // arrayTypeBy0BaPaY03E
            var num22 = table[pbox + arrayTypeBy137EPtr3 - 1] & 0xf
            var num23 = num22 * 4 // arrayTypeBy0BaPaY03E
            var num24 = table[pbox + arrayTypeBy137EPtr3 - 2] & 0xf
            var num25 = num24 * 4 // arrayTypeBy0BaPaY03E
            var arrayTypeBy137EPtr4 = arrayTypeBy137EPtr3 - 6 // pbox

            var numPtr2 = table[wpbox + ((v48[num24] & 0xf) % 4 + num1 * 4) - 4] * 4 // byte_519E5
            var numPtr3 = table[wpbox + ((v48[num22] & 0xf) % 4 + num1 * 4) - 4] * 4 // byte_519E5
            var numPtr4 = table[wpbox + ((v48[num18] & 0xf) % 4 + num1 * 4) - 4] * 4 // byte_519E5
            var numPtr5 = table[wpbox + ((v48[num16] & 0xf) % 4 + num1 * 4) - 4] * 4 // byte_519E5
            var num26 = 4
            do {
                v47[table[pbox + arrayTypeBy137EPtr4] & 0xf] = table[arrayTypeBy0BaPaY03E[num25] + byte_519E5[numPtr2]] ^
                    table[arrayTypeBy0BaPaY03E[num19] + byte_519E5[numPtr4]] ^
                    table[arrayTypeBy0BaPaY03E[num23] + byte_519E5[numPtr3]] ^
                    table[arrayTypeBy0BaPaY03E[num17] + byte_519E5[numPtr5]]
                    ++numPtr5
                    ++numPtr4
                    ++numPtr3
                    ++numPtr2
                    ++arrayTypeBy137EPtr4
                    --num26
            } while (num26 > 0)

            arrayTypeBy137EPtr3 += 8
                --num21
        } while (num21 > 0)
        v48.set(v47, 0)
    } while (num1 < num20)

    var num27 = num1 << 4
    var num28 = 0
    var num29 = num1 * 4
    var num30 = nr * 4
    var num31 = 16
    var num32 = num27 * num31

    var result = 0x8000
    do {
        var num4 = num28 // v47
        output[table[pbox + ((num28 >> 3) + num30) * 8 + (num28 & 7)] & 15] =
            table[result + (4 * (16 * (v48[num4] >> 4) + (v48[num4] & 0xF)) + byte_519E5[4 * table[wpbox + (v48[num4] & 3) + 8]])];

        ++num28
        num32 += 16
        result += 1024
    } while (num28 < 16)

    return output
}

var parseClientHello = function(data) {
    var dataDecTbl = asmCrypto.hex_to_bytes(decTbl.decTbl)
    var keyTransformArray = asmCrypto.hex_to_bytes(keyTransformArray.keyTransformArray)

    var dataBytes = asmCrypto.hex_to_bytes(data)
    var hashBytes = asmCrypto.hex_to_bytes(sakepDict.hash)

    var v65 = convertUint8ToUint32(dataBytes, 7)
    var v67 = convertUint8ToUint32(dataBytes, 11)
    var v17 = v67
    var dest = new Uint8Array(v67 + 152)
    var v21 = v17 + 132

    dest.set(dataBytes.subarray(11, 11 + v21), 0)
    dest.set(hashBytes.subarray(0, 20), v21)

    var v22 = v67 + 1
    var n = v67
    var src = new Uint8Array(v67 + 1)
    src.set(dataBytes.subarray(15, 15 + n), 0)
    var v63 = n + 15
    var v84 = dataBytes.subarray(n + 15, n + 15 + 0x80)
    var v90 = new Uint8Array(0x80)

    var offset = 0
    do {
        var result = SWAPv2_Process(dataDecTbl, 0x28250, v84, offset)
        if (result.value) {
            v90.set(result.value, offset)
        } else {
            log("DEBUG", 'error');
            // log.info(result.error)
        }
        offset += 16
    } while (offset < 128)

    var publicKeyBN = new BN(publicKey, 16)
    var privateKeyBN = new BN(privateKey, 16)

    var primeBN = new BN(prime, 16)
    var generatorBN = new BN(generator, 16)

    var v87 = asmCrypto.AES_CBC.decrypt(v90, sakepDict.aesKey, false)
    var decryptedBN = new BN(asmCrypto.bytes_to_hex(v87), 16)

    // compute shared secret
    var v88 = asmCrypto.hex_to_bytes(decryptedBN.toRed(BN.red(primeBN)).redPow(privateKeyBN).fromRed().toString('hex'))
    var v68 = v88.length

    var s = dataBytes.subarray(v63 + 128, v63 + 128 + 0x14)
    var v24 = asmCrypto.string_to_bytes(sakepDict.userId)
    var v25 = v24
    var v26 = v68
    var c = asmCrypto.bytes_to_hex(v24) + asmCrypto.bytes_to_hex(v88)
    c = asmCrypto.SHA1.bytes(asmCrypto.hex_to_bytes(c))

    if (asmCrypto.bytes_to_hex(c) !== asmCrypto.bytes_to_hex(s)) {
        // bad pin ????
        log("DEBUG", 'error');
        // log.info('error: hash values do not match')
        return -1
    }

    var num14 = v67 + 15 + 128 + 20
    var num21 = 20

    var num10 = dataBytes.subarray(num14)
    if (num10[0] !== 0) {
        log("DEBUG", 'error');
        // log.info('error')
        return -1
    }
    var num2 = convertUint8ToUint32(num10, 1)
    if (num2 !== 0) {
        log("DEBUG", 'error');
        // log.info('error')
        return -1
    }

    var num24 = 16
    var num28 = asmCrypto.SHA1.bytes(dest)
    var numPtr3 = asmCrypto.string_to_bytes(sakepDict.userId)
    var arrayTypeBy0IaE2 = asmCrypto.hex_to_bytes(publicKey)
    var numPtr7 = new Uint8Array(v67 + numPtr3.length + 384)
    var numPtr7Offset = 0
    numPtr7.set(src.subarray(0, v67), numPtr7Offset)
    numPtr7Offset = v67
    numPtr7.set(numPtr3, numPtr7Offset)
    numPtr7Offset += numPtr3.length
    numPtr7.set(v87, numPtr7Offset)
    numPtr7Offset += v87.length
    numPtr7.set(arrayTypeBy0IaE2, numPtr7Offset)
    numPtr7Offset += arrayTypeBy0IaE2.length
    numPtr7.set(v88, numPtr7Offset)

    var ctx16 = asmCrypto.SHA1.bytes(numPtr7).subarray(0, 20)
    var arrayTypeBy0BfE = new Uint8Array(21)

    arrayTypeBy0BfE.set(ctx16, 0)

    var ctx = simpleTransform(keyTransformArray, 3, asmCrypto.SHA1.bytes(arrayTypeBy0BfE))

    sakepDict['ctx'] = new Uint8Array(64)
    sakepDict.ctx.set(ctx)
    sakepDict.ctx.set(ctx16, ctx.length)
    sakepDict.ctx.set(num28, ctx.length + ctx16.length)
    sakepDict.ctx[ctx.length + ctx16.length + num28.length] = 4

    return 0
}

var generateServerAcknowledge = function() {
    var outMessage = '0103000000000000000014'
    var ctx16 = new Uint8Array(21)
    ctx16.set(sakepDict.ctx.subarray(16, 36))
    ctx16[20] = 1
    outMessage += asmCrypto.bytes_to_hex(asmCrypto.SHA1.bytes(ctx16))
    outMessage += '0000000000'
    return outMessage.toUpperCase()
}

var parseClientAcknowledge = function(data) {
    var ctx16 = new Uint8Array(21)
    ctx16.set(sakepDict.ctx.subarray(16, 36))
    ctx16[20] = 2
    var hash = asmCrypto.bytes_to_hex(asmCrypto.SHA1.bytes(ctx16))
    return hash === data.substring(22, 62).toLowerCase()
}

var getKey = function() {
    if (sakepDict.ctx) {
        return asmCrypto.bytes_to_hex(sakepDict.ctx.subarray(0, 16))
    } else {
        return null
    }
}

var encryptData = function(aesKey, sessionKey, data) {
    if (typeof sessionKey === 'string') {
        sessionKey = parseInt(sessionKey)
    }

    var aesKeyBytes = asmCrypto.hex_to_bytes(aesKey)
    var dataBytes = asmCrypto.string_to_bytes(JSON.stringify(data))
    var encryptedData = asmCrypto.AES_ECB.encrypt(dataBytes, aesKeyBytes, true)

    var body = '['
    for (var i = 0; i < encryptedData.length - 1; i++) {
        body += parseInt(encryptedData[i]) + ','
    }
    body += parseInt(encryptedData[encryptedData.length - 1]) + ']'

    return {
        body: body,
        Session_Id: sessionKey
    }
}

var decryptData = function(aesKey, data) {
    var aesKeyBytes = asmCrypto.hex_to_bytes(aesKey)
    var dataBytes = new Uint8Array(JSON.parse(data))
    var decryptedData = asmCrypto.AES_ECB.decrypt(dataBytes, aesKeyBytes, true)
    return asmCrypto.bytes_to_string(decryptedData)
}